#include"table.h"

#include<stdlib.h>

size_t resize(size_t size,int additions,int deletions) {
            int diff;
            size_t newsize;

            diff = additions - deletions;
            if(abs(diff) >= (RESIZERATIO * (double)size)) {
                newsize = (size_t) ((((double)(size << 1)) * additions) /(additions + deletions));
            }
            else {
                newsize = 0;
            }
            return newsize;
       }

table_t hashnew(type_t type,int about,param_t param) {
	  static table_t new;
	  static void * base;

	  if(new = (table_t)calloc(1,sizeof(struct table))) {
               if(type & CLOSED) {
                  new->size = cprime((int)(((double)about) / param.closed.occupancy));
	          if(base = calloc(new->size + COLLISIONMAX,ENTRYSIZE)) {
		        new->base.closed = (entry_t)base;
	          }
               }
	       else {
                  new->size = cprime(about);
                  if(base = calloc(new->size,sizeof(synonym_t))) {
                       new->base.open = (synonym_t *)base;
	          }
               }
               if(! base) {
                    free(new);
                    return NULL;
               }
               new->type = type;
               new->param = param;
	  }
	  return new;
   }

void hashdispose(table_t table) {
          if(table->type & CLOSED) {
  		free(table->base.closed);
          }
          else {
             synonym_t prev,next;
             int pos;

             next = NULL;
             pos = -1;
             while(1) {
                 if(! next) {
                    if((++pos) >= table->size)
                         break;
                    prev = NULL;
                    next = table->base.open[pos];
                    continue;
                 }
                 prev = next;
                 next = next->next;
                 free(prev);
             }
             free(table->base.open);
          }
  	  free(table);
  	  return;
 }

entry_t hashlookup(table_t table,key_t key) {
	if(table->type & CLOSED) {
            hash_fn rehash;
    	    int prev,null,pos;
	    key_t tkey;
            entry_t base;

           null = -1;
	   pos = table->size + collisions(table);
           base = table->base.closed;
           tkey = KEYNULL;
	   while((tkey != key) && ((--pos) >= table->size)) {
		   tkey = base[pos].key;
	   }
           if(tkey != key) {
	   prev = -1;
           hashes = 0;
           rehash = table->param.closed.rehash;
           while(((pos = rehash(key,table->size)) >= 0)
                && ((1 << hashes) <= (table->size << 3))) {
		 ++hashes;
	         tkey = base[pos].key;
                    if(tkey == key) {
                        break;
                    }
                    else {
                      if((! tkey) && (null < 0)) {
		          null = pos;
		       }
		    }
                    prev = pos;
	   }
           }
           if(tkey == key) { 
   	       if(null >= 0) {
		      int temp = null;
		      null = pos;
		      pos = temp;
		      base[temp].key = key;
              	      base[temp].loc = base[null].loc;
		      base[null].key = KEYNULL;
	       }
	        else {
		      if((prev >= 0) && (table->type & POS)) {
		          struct entry temp = base[prev];
		          base[prev] = base[pos];
		          base[pos] = temp;
		          pos = prev;
		      }
		}
          }
          table->ptr.closed.pos = pos;
          table->ptr.closed.null = null;
          return (tkey == key) ? base + pos : NULL;
      }
      else {
        int pos;
        synonym_t curr;

        pos = table->param.hash(key,table->size);
        curr = table->base.open[pos];
        if(curr) {
           while((curr->entry.key < key) && curr->next) {
                  curr = curr->next;
           }
        }
        table->ptr.open.pos = pos;
        table->ptr.open.curr = curr;
        return curr && curr->entry.key == key ? &(curr->entry) : NULL;
      }
   }

table_t hashadd(table_t table,entry_t entry) {
          if((entry->key == KEYNULL) || hashlookup(table,entry->key)) {
                 return NULL;
          }
          if(table->type & CLOSED) {
             entry_t base;
             int pos,null;

             null = table->ptr.closed.null;
             base = table->base.closed;
	     if(null >= 0) {
		 base[null] = *entry;
	         table->count[3]++;
	     }
	     else {
		  if(collisions(table) < COLLISIONMAX) {
			pos = collisions(table) + table->size;
			base[pos] = *entry;
		  }
		  else {
			return NULL;
		  }
	     }
          }
          else {
              static synonym_t new;
              synonym_t curr;

              new = (synonym_t)calloc(1,SYNONYMSIZE);
              if(! new)
                  return NULL;
              new->entry = *entry;
              curr = table->ptr.open.curr;
              if(! curr) {
                 synonym_t *first;

                 first = table->base.open + table->ptr.open.pos;
                 new->next = *first;
                 if(*first) {
                    (*first)->prev = new;
                 }
                 *first = new;
              }
              else {
                if(curr->entry.key > entry->key) {
                       new->next = curr;
                       new->prev = curr->prev;
                       if(curr->prev) {
                          curr->prev->next = new;
                       }
                       curr->prev = new;
                }
                else {
                      new->next = curr->next;
                      if(curr->next) {
                           curr->next->prev = new;
                      }
                      curr->next = new;
                      new->prev = curr;
                }
             }
             table->ptr.open.curr = new;
         }
         table->count[0]++;
         table->count[1]++;
	 return table;
 }

table_t hashremove(table_t table,key_t key) {
	   if(key == KEYNULL || (! hashlookup(table,key))) {
	        return NULL;
	   }
	   if(table->type & CLOSED) {
                 entry_t base;

                 base = table->base.closed;
		 if(table->ptr.closed.pos >= table->size) {
		    base[table->ptr.closed.pos] = base[table->size + collisions(table)];
		 }
                 else {
                    base[table->ptr.closed.pos].key = KEYNULL;
		    table->count[3]--;
                 }
            }
            else {
               synonym_t temp;

               temp = table->ptr.open.curr;
               table->ptr.open.curr = temp->next;
               if(temp->prev) {
                   temp->prev->next = temp->next;
               }
               else {
                   table->base.open[table->ptr.open.pos] = temp->next;
               }   
               if(temp->next) {
                   temp->next->prev = temp->prev;
               }
               free(temp);
           }
           table->count[0]--;
           table->count[2]++;
	   return table;
}

table_t *hashresize(table_t *table,size_t newsize) {
		table_t old,new;

		old = (*table);
                if(! (new = hashnew(old->type,newsize,old->param))) {
                   return NULL;
                }
                if(old->type & CLOSED) {
                  entry_t base;
                  int pos;

                  base = old->base.closed;
		  pos = old->size + collisions(old);
		  while(1) {
                     --pos;
                     if(pos < 0)
                         break;
		     if(base[pos].key != KEYNULL) {
			 if(! hashadd(new,&base[pos])) {
				hashdispose(new);
				return NULL;
			 }
		     }
		  }
                  free(base);
               } 
               else {
	           synonym_t prev,curr;
                   synonym_t *base;
                   int pos,size;

                   prev = NULL;
                   curr = NULL;
                   pos = -1;
                   size = old->size;
                   base = (old->base).open;
                   if(old->type & ORDERED) {
		        int index,newindex = -1;

                        while(1) {
                  		if(! curr) {
                                        ++pos;
					if(pos >= size)
                                              break;
					curr = base[pos];
                                        if(curr) {
                                               curr->prev = prev;
					       if(prev) {
                                                   prev->next = curr;
                                               }
                                        }
					continue;
		   		}
		   		index = new->param.hash(curr->entry.key,new->size);
		   		if(index != newindex) {
		      			if(prev)
                                            prev->next = NULL;
                                        curr->prev = NULL;
		    			newindex = index;
		      			new->base.open[index] = curr;
		   		}
		   		prev = curr;
		   		curr = curr->next;
			} 
             	  }
             	  else {
			while(1) {
		   		if(! curr) {
			  		if((++pos) >= size) break;
			  		curr = base[pos];
			  		continue;
		   		}
                   		hashlookup(new,curr->entry.key);
		   		pos = new->ptr.open.pos;
                   		prev = new->ptr.open.curr;
                   		if(! prev) {
                         		curr->next = NULL;
                         		new->base.open[pos] = curr;
                   		}
                   		else {
                       			curr->next = prev->next;
                       			prev->next = curr;
                   		}
		   		curr = curr->next;
			}
                  }
                  free(base);
           }
           new->count[0] = old->count[0];
           new->count[1] = old->count[1];
	   new->count[2] = old->count[2];
           free(old);
	   (*table) = new;
	   return table;
       }

entry_t hashget(table_t table,get_t get) {
	   int pos,size;

	   if(count(table) <= 0) {
                 return NULL;
           }
             if(table->type & CLOSED) {
                entry_t base;

                base = table->base.closed;
	        size = table->size + collisions(table);
		switch(get) {
                        case GETCURR : {
                                        pos = table->ptr.closed.pos;
                                        break;
                                       }
			case GETLAST :{
				  pos = size;
			}
			case GETPREV :{
				   if(get == GETPREV) {
					pos = table->ptr.closed.pos;
	  			    }
				while(((--pos) >= 0) &&
                                    (! base[pos].key))
			                 ;
					 break;
			}
			case GETFIRST :{
				  pos = -1;
			}
			case GETNEXT :{
				if(get == GETNEXT) {
				   if((pos = table->ptr.closed.pos) < 0) {
					  break;
				   }
				}
			    while(((++pos) < size) &&
                                   (! base[pos].key))
				        ;
				   break;
			 }
				default : pos = -1;
			 }
		  table->ptr.closed.pos = pos;
		  return (pos >= 0 && pos < size) ? &base[pos] : NULL;
              }
              else {
		synonym_t *base,curr;

		base = table->base.open;
                size = table->size;
		switch(get) {
                case GETCURR : {
                               curr = table->ptr.open.curr;
                               break;
                               }
		case GETLAST : {
				pos = table->size;
                               }
                case GETPREV : {
                                if(get == GETPREV) {
                                   curr = table->ptr.open.curr;
                                   if(curr->prev) {
                                        curr = curr->prev;
                                        break;
                                   }
                                   pos = table->ptr.open.pos;
                                } 
				while(((--pos) >= 0) && (! base[pos]));
				if(pos >= 0) {
				   curr = base[pos];
				while(curr->next) {
				  curr = curr->next;
				}
                                }
                                break;
			      }
		case GETFIRST :{
			pos = -1;
                        curr = NULL;
	        }
		case GETNEXT :{
                           if(get == GETNEXT) {
                              pos = table->ptr.open.pos;
			      curr = table->ptr.open.curr;
                           }
			   if(curr && curr->next) {
                             curr = curr->next;
                           }
                           else {
	   		   while(((++pos) < size) && (!(curr = base[pos])))
                                  ;
                           }
			   break;
		     }
		  default : return NULL;
	   }
           table->ptr.open.pos = pos;
           table->ptr.open.curr = curr;
           return (pos >= 0) && (pos < size) ? &curr->entry : NULL;
	  }
       }
